#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "el.h"

#define ROVM
#include "regex.h"

/*
  ROVM Server  ϴ Class   ڿ ü Ű ŬԴϴ.
  Core Ŭ  ϳν, ڿ VM  ߿  ,  Ŭ 
  ü ڵ ȯǰ ˴ϴ.   StringRef  ٷ  Ŭ ObjectRef
   Դϴ.
  
  !!!!
  StringRef  value ʵ ſ Ưϰ Ǿ ϴ κԴϴ.  
   value ʵ , Type  `['  ArrayRef   , 
  ޸   ش ArrayRef  ƴմϴ.  ̷  Ű 
  value   RvValue ü STACK_IS_STRINGVALUE (NODE)  1  
  Ǿ ֽϴ.
 */

/* need to include <ctype.h> to use these macros */
#ifndef ISPRINT
#define ISASCII(c) isascii((int)(unsigned char)(c))
#undef ISPRINT
#define ISPRINT(c) (ISASCII(c) && isprint((int)(unsigned char)(c)))
#define ISSPACE(c) (ISASCII(c) && isspace((int)(unsigned char)(c)))
#define ISUPPER(c) (ISASCII(c) && isupper((int)(unsigned char)(c)))
#define ISLOWER(c) (ISASCII(c) && islower((int)(unsigned char)(c)))
#define ISALNUM(c) (ISASCII(c) && isalnum((int)(unsigned char)(c)))
#define ISALPHA(c) (ISASCII(c) && isalpha((int)(unsigned char)(c)))
#define ISDIGIT(c) (ISASCII(c) && isdigit((int)(unsigned char)(c)))
#define ISXDIGIT(c) (ISASCII(c) && isxdigit((int)(unsigned char)(c)))
#endif

void *
xmalloc (size_t size)
{
  return malloc (size);
}

void
xfree (void *ptr)
{
  free (ptr);
}

void *
xrealloc (void *ptr, size_t size)
{
  return realloc (ptr, size);
}

unsigned long
scan_oct(start, len, retlen)
    const char *start;
    int len;
    int *retlen;
{
  register const char *s = start;
  register unsigned long retval = 0;
  
  while (len-- && *s >= '0' && *s <= '7') 
    {
      retval <<= 3;
      retval |= *s++ - '0';
    }
  *retlen = s - start;
  return retval;
}

unsigned long
scan_hex(start, len, retlen)
    const char *start;
    int len;
    int *retlen;
{
  static char hexdigit[] = "0123456789abcdef0123456789ABCDEF";
  register const char *s = start;
  register unsigned long retval = 0;
  char *tmp;
  
  while (len-- && *s && (tmp = strchr(hexdigit, *s))) 
    {
      retval <<= 4;
      retval |= (tmp - hexdigit) & 15;
      s++;
    }
  *retlen = s - start;
  return retval;
}

static RvFieldDef field[] = 
  {
    /* !!!!
       StringRef  value ʵ ſ Ưϰ Ǿ ϴ κԴϴ.  
        value ʵ , Type  `['  ArrayRef   , 
       ޸   ش ArrayRef  ƴմϴ.  ̷  Ű 
       value   RvValue ü STACK_IS_STRINGVALUE (NODE)  1  
       Ǿ ֽϴ.  */
    { "value",  "[" },
    { "len",    "I" },
    { NULL, NULL },
  };

/**
  ʱȭ ޽ : __init__ (TSI)V

  ڿ S   I  о鿩, Field  value  len  մϴ.
*/
static int
str_init_tsi (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  char *str;
  int len;

  if (RvParseArg (self, args, "si", &str, &len))
    return -1;

  /* .  */
  
  return 0;
}

/*
  Ʒ split ޽ 3  , ϳ  Լ   ִ Դϴٸ
    ؼ    ·  ִ Դϴ.

  ̸  ں ʴϴ! (2006-02-19)
 */

/**
  Split ޽ : split (T)[

  SELF  StringRef  Ͽ, ڿ ISPACE   split Ͽ
  ׿  迭 ȯմϴ.
  
  @return       ڿ ISPACE  split   迭Դϴ.
*/
static int
str_split_t (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int len, skip = 1, limit = 0, lim = 0;
  char *str, *ptr, *eptr;
  long beg, end, i = 0;
  RvObject *result, *tmp;

  /* StringRef  ArrayRef  value  Ưϰ   Ѵ.  */
  /* SELF  StringRef ̱  ׿  ڿ ̸ Ѵ.  */
  if (RvStrGetInfo (self, &str, &len))
    return -1;

  ptr = str;

  result = RvArrayNew (self);
  eptr = ptr + len;

  for (end = beg = 0; ptr<eptr; ptr++)
    {
      if (skip) 
        {
          if (ISSPACE (*ptr))
            beg++;
          else 
            {
              end = beg + 1;
              skip = 0;
              if (!(limit == 0) && lim <= i) 
                break;
            }
        }
      else 
        {
          if (ISSPACE (*ptr)) 
            {
              RvArrayPush (result, "S", RvStrSubstr (self, str, beg, end - beg));
              skip = 1;
              beg = end + 1;
              if (!(limit == 0)) 
                ++i;
            }
          else
            end++;
        }
    }

  if (len > 0 && (!(limit == 0) || len > beg || lim < 0)) 
    {
      if (len == beg)
        fprintf (stderr, "Can't handle this situation.");
      else
        tmp = RvStrSubstr (self, str, beg, len - beg);
      RvArrayPush (result, "S", tmp);
    }

  if ((limit == 0) && lim == 0)
    {
      while (RvArrayLength (result) > 0)
        {
          RvValue *last;

          last = RvArrayLastValue (result);
          if (!last)
            break;

          if (RvGetField (RvValueStringRef (last), "len", "I", &len))
            return -1;

          if (len > 0)
            break;

          RvArrayPop (result);
        }
    }

  RvSetReturn (self, ret, "[", result);

  return 0;
}

/**
  Split ޽ : split (TS)[

  SELF  StringRef  Ͽ, ڿ ι° argument   split Ͽ
  ׿  迭 ȯմϴ.
  
  @return       ڿ ι°  (StringRef)  split   迭Դϴ.
*/
static int
str_split_ts (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int limit = 0, lim = 0;
  long i = 0;
  char *str, *pat, *error;
  int strlen, patlen;
  long beg;
  regex_t *re;
  int last_null;
  long idx;
  long start = 0, end;
  struct re_registers re_regs, *regs = NULL;
  RvObject *result, *tmp;

#define BEG(no) regs->beg[no]
#define END(no) regs->end[no]

  if (RvParseArg (self, args, "s#", &pat, &patlen))
    return -1;

  /* SELF  StringRef ̱  ׿  ڿ ̸ Ѵ.  */
  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  re = (regex_t *) calloc (1, sizeof (regex_t));
  memset (&re_regs, '\0', sizeof (struct re_registers));
  error = re_compile_pattern (pat, patlen, re);
  if (error)
    {
      fprintf (stderr, "%s", error);
      return -1;
    }

  result = RvArrayNew (self);

  beg = 0;
  last_null = beg;
  while ((end = re_search (re, str, strlen, start, strlen - start, &re_regs)) >= 0)
    {
      regs = &re_regs;
      if (start == end && BEG (0) == END (0)) 
        {
          if (!str)
            {
              RvArrayPush (result, "S", RvStrNew (self, "", 0));
              break;
            }
          else if (last_null == 1) 
            {
              RvArrayPush (result, "S", RvStrSubstr (self, str, beg, mbclen (str[beg])));
              beg = start;
            }
          else 
            {
              start += mbclen (str[start]);
              last_null = 1;
              continue;
            }
        }
      else 
        {
          RvArrayPush (result, "S", RvStrSubstr (self, str, beg, end - beg));
          beg = start = END (0);
        }
      last_null = 0;
      
      for (idx=1; idx < regs->num_regs; idx++)
        {
          if (BEG (idx) == -1)
            continue;
          if (BEG (idx) == END (idx))
            {
              fprintf (stderr, "TODO");
              tmp = NULL;
            }
          else
            tmp = RvStrSubstr (self, str, BEG (idx), END (idx) - BEG (idx));
          
          RvArrayPush (result, "S", tmp);
        }
      if (!(limit == 0) && lim <= ++i) break;
    }
  
  if (strlen > 0 && (!(limit == 0) || strlen > beg || lim < 0)) 
    {
      if (strlen == beg)
        {
          fprintf (stderr, "Can't handle this situation.");
          tmp = NULL;
        }
      else
        tmp = RvStrSubstr (self, str, beg, strlen - beg);
      RvArrayPush (result, "S", tmp);
    }

  if ((limit == 0) && lim == 0)
    {
      while (RvArrayLength (result) > 0)
        {
          int len;
          RvValue *last;

          last = RvArrayLastValue (result);
          if (!last)
            break;

          if (RvGetField (RvValueStringRef (last), "len", "I", &len))
            return -1;

          if (len > 0)
            break;

          RvArrayPop (result);
        }
    }
  
  RvSetReturn (self, ret, "[", result);
  
  if (regs)
    re_free_registers (regs);
  re_free_pattern (re);

  return 0;
}

/**
  Split ޽ : split (TSI)[

  SELF  StringRef  Ͽ, ڿ ι° argument   split Ͽ
  ׿  迭 ȯմϴ.  , max limit   ֽϴ.
  
  @return       ڿ ι°  (StringRef)  split   迭Դϴ.
*/
static int
str_split_tsi (self, args, ret)
     RvObject *self;
     RvValue *args, *ret;
{
  int limit = 1, lim = 0;
  long i = 0;
  char *str, *pat, *error;
  int strlen, patlen;
  long beg;
  regex_t *re;
  int last_null;
  long idx;
  long start = 0, end;
  struct re_registers re_regs, *regs = NULL;
  RvObject *result, *tmp;

#define BEG(no) regs->beg[no]
#define END(no) regs->end[no]

  if (RvParseArg (self, args, "s#i", &pat, &patlen, &lim))
    return -1;

  /* SELF  StringRef ̱  ׿  ڿ ̸ Ѵ.  */
  if (RvStrGetInfo (self, &str, &strlen))
    return -1;

  if (lim <= 0)
    limit = 0;
  else if (lim == 1)
    {
      if (strlen == 0)
        {
          RvSetReturn (self, ret, "[", RvArrayNew (self));
          return 0;
        }
      result = RvArrayNew (self);
      RvArrayPush (result, "S", RvStrSubstr (self, str, 0, strlen));
      RvSetReturn (self, ret, "[", result);
      return 0;
    }
  i = 1;

  re = (regex_t *) calloc (1, sizeof (regex_t));
  memset (&re_regs, '\0', sizeof (struct re_registers));
  error = re_compile_pattern (pat, patlen, re);
  if (error)
    {
      fprintf (stderr, "%s", error);
      return -1;
    }

  result = RvArrayNew (self);

  beg = 0;
  last_null = beg;
  while ((end = re_search (re, str, strlen, start, strlen - start, &re_regs)) >= 0)
    {
      regs = &re_regs;
      if (start == end && BEG (0) == END (0)) 
        {
          if (!str)
            {
              RvArrayPush (result, "S", RvStrNew (self, "", 0));
              break;
            }
          else if (last_null == 1) 
            {
              RvArrayPush (result, "S", RvStrSubstr (self, str, beg, mbclen (str[beg])));
              beg = start;
            }
          else 
            {
              start += mbclen (str[start]);
              last_null = 1;
              continue;
            }
        }
      else 
        {
          RvArrayPush (result, "S", RvStrSubstr (self, str, beg, end - beg));
          beg = start = END (0);
        }
      last_null = 0;
      
      for (idx=1; idx < regs->num_regs; idx++)
        {
          if (BEG (idx) == -1)
            continue;
          if (BEG (idx) == END (idx))
            {
              fprintf (stderr, "TODO");
              tmp = NULL;
            }
          else
            tmp = RvStrSubstr (self, str, BEG (idx), END (idx) - BEG (idx));
          
          RvArrayPush (result, "S", tmp);
        }
      if (!(limit == 0) && lim <= ++i) break;
    }
  
  if (strlen > 0 && (!(limit == 0) || strlen > beg || lim < 0)) 
    {
      if (strlen == beg)
        {
          fprintf (stderr, "Can't handle this situation.");
          tmp = NULL;
        }
      else
        tmp = RvStrSubstr (self, str, beg, strlen - beg);
      RvArrayPush (result, "S", tmp);
    }

  if ((limit == 0) && lim == 0)
    {
      while (RvArrayLength (result) > 0)
        {
          int len;
          RvValue *last;

          last = RvArrayLastValue (result);
          if (!last)
            break;

          if (RvGetField (RvValueStringRef (last), "len", "I", &len))
            return -1;

          if (len > 0)
            break;

          RvArrayPop (result);
        }
    }
  
  RvSetReturn (self, ret, "[", result);
  
  if (regs)
    re_free_registers (regs);
  re_free_pattern (re);

  return 0;
}

static RvMethodDef method[] =
  {
    { "__init__",       "(TSI)V",       str_init_tsi },
    { "split",          "(T)[",         str_split_t },
    { "split",          "(TS)[",        str_split_ts },
    { "split",          "(TSI)[",       str_split_tsi },
    { NULL, },
  };

/** entry point.  */
int
init_str (RvClass *cls)
{
  if (RvDefineFields (cls, field))
    return -1;

  if (RvDefineMethods (cls, method))
    return -1;

  return 0;
}
